unit ObjGraph;
interface
   uses
      Objects, KeyMouse, GraphDrv, Rects;

   var
      ScreenRect   :TmRect;

   procedure SetGraphMode;

   procedure PutImage(var Origin       :TPoint;
                      Buffer           :Pointer);

   procedure GetImage(var Bounds       :TRect;
                      Buffer           :Pointer);

   function  ImageSize(var Bounds      :TRect): Word;

   procedure PutBlock(var Origin       :TPoint;
                      Buffer           :Pointer);

   function  InScreen(Point            :TPoint): Boolean;

   procedure SetDriverOutput(GOutput   :TDriverOutput);


   procedure Line     (Pos             :TRect;
                       Color           :Integer);

   procedure Rectangle(Rect            :TRect;
                       Color           :Integer);

   procedure Bar      (Rect            :TRect;
                       Color           :Integer);

implementation

   procedure PutImage;
   begin
      HideMouse;
      GraphDrv.PutImage(Origin.X, Origin.Y, Buffer);
      ShowMouse;
   end;

   procedure GetImage;
   begin
      HideMouse;
      GraphDrv.GetImage(
         Bounds.A.X, Bounds.A.Y, Bounds.B.X, Bounds.B.Y, Buffer);
      ShowMouse;
   end;

   function ImageSize;
   begin
      ImageSize:=GraphDrv.ImageSize(
         Bounds.A.X, Bounds.A.Y, Bounds.B.X, Bounds.B.Y);
   end;

   procedure PutBlock;
   begin
      HideMouse;
      GraphDrv.PutBlock(Origin.X, Origin.Y, Buffer);
      ShowMouse;
   end;

   function InScreen;
   begin
      InScreen:=ScreenRect.Contains(Point);
   end;

   procedure SetDriverOutput;
   begin
      MouseOn:=(GOutput<>ToBuffer);
      GraphDrv.SetDriverOutput(GOutput);
   end;

   procedure SetGraphMode;
   begin
      GraphDrv.SetGraphMode;
      KeyMouse.MouseConvX:=GraphDrv.DriverPTR^.MouseConvX;
      KeyMouse.MouseConvY:=GraphDrv.DriverPTR^.MouseConvY;
      LongInt(ScreenRect.A):=0;
      ScreenRect.B.X:=GetMaxX; ScreenRect.B.Y:=GetMaxY;
   end;

   procedure Line;
   begin
      GraphDrv.Line(Pos.A.X, Pos.A.Y, Pos.B.X, Pos.B.Y, Color);
   end;

   procedure Rectangle;
   begin
      GraphDrv.Rectangle(Rect.A.X, Rect.A.Y, Rect.B.X, Rect.B.Y, Color);
   end;

   procedure Bar;
   begin
      GraphDrv.Rectangle(Rect.A.X, Rect.A.Y, Rect.B.X, Rect.B.Y, Color);
   end;

end.
